-- =============================================  
-- Author:  <Author,,Name>  
-- Create date: <Create Date,,>  
-- Description: <Description,,>  
-- =============================================  
CREATE procedure [C6MartPeriodicoImmobiliare].[RP_DM_ASSET_PERC_TERZI]  
AS  
BEGIN  
 SET NOCOUNT ON;  
 DECLARE @ID_ELAB INT  
 DECLARE @TIPO_ELAB VARCHAR(1)  
 SET @ID_ELAB = C6MartPeriodico.GETIDELAB()  
 SET @TIPO_ELAB = C6MartPeriodico.GETTIPOELAB()  
 -- Log esecuzione  
 INSERT INTO LOG_ESECUZIONE_PERIODICO_IMMOBILIARE  
  (Nome, Inizio, Nota)  
 VALUES (  
  'RP_DM_ASSET_PERC_TERZI',  
  GETDATE(),  
  'Mart Immobiliare'  
 )  
 TRUNCATE TABLE C6MartPeriodicoImmobiliare.ASSET_PERC_TERZI  
 INSERT INTO [C6MartPeriodicoImmobiliare].[ASSET_PERC_TERZI]  
  ([COD_PRODOTTO_TERZI] --  
  ,[ID_ASSETCLASS] --  
  ,[LIVELLO] --  
  ,[NOME_PRODOTTO]  
  ,[TIPO_PRODOTTO]  
  ,[PERC] --  
  ,[ID_ELAB]  
  ,[TIPO_ELAB])  
 SELECT DISTINCT  
  ISNULL(Temp_oidProd, RP_PatrimonioTerzi.chiaveProdottoTerzi) AS COD_PRODOTTO_TERZI,  
  RP_AssetClass.Asset AS ID_ASSETCLASS,  
  RP_AssetClass.Livello AS LIVELLO,  
  NULL AS NOME_PRODOTTO,  
  NULL AS TIPO_PRODOTTO,  
  RP_MappaturaPT.percentuale / 100 AS PERC,  
  @ID_ELAB AS ID_ELAB,  
  @TIPO_ELAB AS TIPO_ELAB  
 FROM  
  C6StagingPeriodicoImmobiliare.RP_PatrimonioTerzi  
 INNER JOIN  
  C6StagingPeriodicoImmobiliare.RP_DettProdottiTerzi  
 ON  
  C6StagingPeriodicoImmobiliare.RP_PatrimonioTerzi.chiaveProdottoTerzi = C6StagingPeriodicoImmobiliare.RP_DettProdottiTerzi.chiaveProdottoTerzi  
 INNER JOIN  
  C6StagingPeriodicoImmobiliare.RP_S4_S5_S13_TRAD_UNTIL_LIV3  
 ON  
  C6StagingPeriodicoImmobiliare.RP_DettProdottiTerzi.alberatura = C6StagingPeriodicoImmobiliare.RP_S4_S5_S13_TRAD_UNTIL_LIV3.alberatura  
 INNER JOIN  
  C6StagingPeriodicoImmobiliare.RP_MappaturaPT  
 ON  
  C6StagingPeriodicoImmobiliare.RP_PatrimonioTerzi.chiaveProdottoTerzi = C6StagingPeriodicoImmobiliare.RP_MappaturaPT.chiaveProdottoTerzi  
 INNER JOIN  
  C6StagingPeriodicoImmobiliare.RP_AssetClass  
 ON  
  C6StagingPeriodicoImmobiliare.RP_MappaturaPT.asset = C6StagingPeriodicoImmobiliare.RP_AssetClass.Asset  
 LEFT JOIN  
  C6StagingPeriodicoImmobiliare.RP_MappingTerzi Mapping  
 ON  
  C6StagingPeriodicoImmobiliare.RP_PatrimonioTerzi.chiaveProdottoTerzi = Mapping.chiaveProdottoTerzi  
 -- Log esecuzione  
 UPDATE  
  LOG_ESECUZIONE_PERIODICO_IMMOBILIARE  
 SET  
  Fine = GETDATE(),  
  Tipo = 'INSERT',  
  Righe = @@ROWCOUNT  
 WHERE  
  Nome = 'RP_DM_ASSET_PERC_TERZI' AND  
  Inizio = (  
   SELECT  
    MAX(Inizio)  
   FROM  
    LOG_ESECUZIONE_PERIODICO_IMMOBILIARE  
   WHERE  
    Nome = 'RP_DM_ASSET_PERC_TERZI'  
  )  
END